
#line 1 "lexer.rl"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <math.h>

#include "parse.h"
#include "parser.h"
#include "../query_node.h"
#include "../stopwords.h"

/* forward declarations of stuff generated by lemon */
void RSQuery_Parse(void *yyp, int yymajor, QueryToken yyminor, QueryParseCtx *ctx);
void *RSQuery_ParseAlloc(void *(*mallocProc)(size_t));
void RSQuery_ParseFree(void *p, void (*freeProc)(void *));


#line 162 "lexer.rl"



#line 25 "lexer.c"
static const char _query_actions[] = {
	0, 1, 0, 1, 1, 1, 2, 1, 
	7, 1, 8, 1, 9, 1, 10, 1, 
	11, 1, 12, 1, 13, 1, 14, 1, 
	15, 1, 16, 1, 17, 1, 18, 1, 
	19, 1, 20, 1, 21, 1, 22, 1, 
	23, 1, 24, 1, 25, 1, 26, 2, 
	2, 3, 2, 2, 4, 2, 2, 5, 
	2, 2, 6
};

static const char _query_key_offsets[] = {
	0, 1, 2, 4, 37, 46, 47, 50, 
	53, 55, 67, 71, 78, 88
};

static const char _query_trans_keys[] = {
	110, 102, 48, 57, 32, 34, 39, 40, 
	41, 42, 43, 45, 58, 64, 91, 93, 
	95, 105, 124, 126, 127, 0, 8, 9, 
	13, 14, 31, 33, 47, 48, 57, 59, 
	63, 92, 96, 123, 125, 96, 0, 47, 
	58, 64, 91, 94, 123, 127, 105, 105, 
	48, 57, 46, 48, 57, 48, 57, 46, 
	96, 0, 47, 48, 57, 58, 64, 91, 
	94, 123, 127, 65, 90, 97, 122, 95, 
	48, 57, 65, 90, 97, 122, 96, 110, 
	0, 47, 58, 64, 91, 94, 123, 127, 
	96, 102, 0, 47, 58, 64, 91, 94, 
	123, 127, 0
};

static const char _query_single_lengths[] = {
	1, 1, 0, 17, 1, 1, 1, 1, 
	0, 2, 0, 1, 2, 2
};

static const char _query_range_lengths[] = {
	0, 0, 1, 8, 4, 0, 1, 1, 
	1, 5, 2, 3, 4, 4
};

static const char _query_index_offsets[] = {
	0, 2, 4, 6, 32, 38, 40, 43, 
	46, 48, 56, 59, 64, 71
};

static const char _query_indicies[] = {
	1, 0, 2, 0, 4, 3, 7, 9, 
	10, 11, 12, 13, 10, 14, 16, 17, 
	18, 19, 20, 21, 22, 23, 6, 6, 
	7, 6, 8, 15, 8, 8, 8, 5, 
	0, 0, 0, 0, 0, 5, 25, 24, 
	25, 27, 26, 29, 27, 28, 4, 28, 
	29, 28, 28, 15, 28, 28, 28, 5, 
	30, 30, 24, 30, 30, 30, 30, 31, 
	32, 33, 32, 32, 32, 32, 5, 32, 
	34, 32, 32, 32, 32, 5, 0
};

static const char _query_trans_targs[] = {
	3, 1, 3, 3, 8, 4, 3, 3, 
	3, 3, 5, 3, 3, 3, 6, 9, 
	3, 10, 3, 3, 4, 12, 3, 3, 
	3, 0, 3, 7, 3, 2, 11, 3, 
	3, 13, 4
};

static const char _query_trans_actions[] = {
	45, 0, 7, 43, 0, 56, 31, 27, 
	29, 9, 53, 13, 15, 21, 50, 5, 
	17, 0, 23, 25, 53, 0, 11, 19, 
	39, 0, 37, 5, 33, 0, 0, 35, 
	41, 0, 47
};

static const char _query_to_state_actions[] = {
	0, 0, 0, 1, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0
};

static const char _query_from_state_actions[] = {
	0, 0, 0, 3, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0
};

static const char _query_eof_trans[] = {
	1, 1, 4, 0, 1, 25, 27, 29, 
	29, 29, 25, 32, 33, 33
};

static const int query_start = 3;
static const int query_first_final = 3;
static const int query_error = -1;

static const int query_en_main = 3;


#line 165 "lexer.rl"



QueryNode *Query_Parse(QueryParseCtx *q, char **err) {
  void *pParser = RSQuery_ParseAlloc(malloc);

  
  int cs, act;
  const char* ts = q->raw;
  const char* te = q->raw + q->len;
  
#line 136 "lexer.c"
	{
	cs = query_start;
	ts = 0;
	te = 0;
	act = 0;
	}

#line 176 "lexer.rl"
  QueryToken tok = {.len = 0, .pos = 0, .s = 0};
  
  //parseCtx ctx = {.root = NULL, .ok = 1, .errorMsg = NULL, .q = q};
  const char* p = q->raw;
  const char* pe = q->raw + q->len;
  const char* eof = pe;
  
  
#line 153 "lexer.c"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
_resume:
	_acts = _query_actions + _query_from_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 1:
#line 1 "NONE"
	{ts = p;}
	break;
#line 172 "lexer.c"
		}
	}

	_keys = _query_trans_keys + _query_key_offsets[cs];
	_trans = _query_index_offsets[cs];

	_klen = _query_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _query_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _query_indicies[_trans];
_eof_trans:
	cs = _query_trans_targs[_trans];

	if ( _query_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _query_actions + _query_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 2:
#line 1 "NONE"
	{te = p+1;}
	break;
	case 3:
#line 60 "lexer.rl"
	{act = 3;}
	break;
	case 4:
#line 108 "lexer.rl"
	{act = 9;}
	break;
	case 5:
#line 144 "lexer.rl"
	{act = 15;}
	break;
	case 6:
#line 146 "lexer.rl"
	{act = 17;}
	break;
	case 7:
#line 60 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    tok.s = ts;
    tok.len = te-ts;
    
    tok.numval = *ts == '-' ? -INFINITY : INFINITY;
    RSQuery_Parse(pParser, NUMBER, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 8:
#line 72 "lexer.rl"
	{te = p+1;{
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, QUOTE, tok, q);  
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 9:
#line 79 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, OR, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 10:
#line 86 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, LP, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 11:
#line 93 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, RP, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 12:
#line 100 "lexer.rl"
	{te = p+1;{ 
     tok.pos = ts-q->raw;
     RSQuery_Parse(pParser, COLON, tok, q);
     if (!q->ok) {
      {p++; goto _out; }
    }
   }}
	break;
	case 13:
#line 115 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, TILDE, tok, q);  
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 14:
#line 122 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, STAR, tok, q);    
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 15:
#line 129 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, LSQB, tok, q);  
    if (!q->ok) {
      {p++; goto _out; }
    }  
  }}
	break;
	case 16:
#line 136 "lexer.rl"
	{te = p+1;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, RSQB, tok, q);   
    if (!q->ok) {
      {p++; goto _out; }
    } 
  }}
	break;
	case 17:
#line 143 "lexer.rl"
	{te = p+1;}
	break;
	case 18:
#line 144 "lexer.rl"
	{te = p+1;}
	break;
	case 19:
#line 145 "lexer.rl"
	{te = p+1;}
	break;
	case 20:
#line 39 "lexer.rl"
	{te = p;p--;{ 
    tok.s = ts;
    tok.len = te-ts;
    char *ne = (char*)te;
    tok.numval = strtod(tok.s, &ne);
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, NUMBER, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
    
  }}
	break;
	case 21:
#line 51 "lexer.rl"
	{te = p;p--;{
    tok.pos = ts-q->raw;
    tok.len = te - (ts + 1);
    tok.s = ts+1;
    RSQuery_Parse(pParser, MODIFIER, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 22:
#line 108 "lexer.rl"
	{te = p;p--;{ 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, MINUS, tok, q);  
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 23:
#line 144 "lexer.rl"
	{te = p;p--;}
	break;
	case 24:
#line 146 "lexer.rl"
	{te = p;p--;{
    tok.len = te-ts;
    tok.s = ts;
    tok.numval = 0;
    tok.pos = ts-q->raw;
    if (!StopWordList_Contains(q->stopwords, tok.s, tok.len)) {
      RSQuery_Parse(pParser, TERM, tok, q);
    } else {
      RSQuery_Parse(pParser, STOPWORD, tok, q);
    }
    if (!q->ok) {
      {p++; goto _out; }
    }
  }}
	break;
	case 25:
#line 39 "lexer.rl"
	{{p = ((te))-1;}{ 
    tok.s = ts;
    tok.len = te-ts;
    char *ne = (char*)te;
    tok.numval = strtod(tok.s, &ne);
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, NUMBER, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
    
  }}
	break;
	case 26:
#line 1 "NONE"
	{	switch( act ) {
	case 3:
	{{p = ((te))-1;} 
    tok.pos = ts-q->raw;
    tok.s = ts;
    tok.len = te-ts;
    
    tok.numval = *ts == '-' ? -INFINITY : INFINITY;
    RSQuery_Parse(pParser, NUMBER, tok, q);
    if (!q->ok) {
      {p++; goto _out; }
    }
  }
	break;
	case 9:
	{{p = ((te))-1;} 
    tok.pos = ts-q->raw;
    RSQuery_Parse(pParser, MINUS, tok, q);  
    if (!q->ok) {
      {p++; goto _out; }
    }
  }
	break;
	case 17:
	{{p = ((te))-1;}
    tok.len = te-ts;
    tok.s = ts;
    tok.numval = 0;
    tok.pos = ts-q->raw;
    if (!StopWordList_Contains(q->stopwords, tok.s, tok.len)) {
      RSQuery_Parse(pParser, TERM, tok, q);
    } else {
      RSQuery_Parse(pParser, STOPWORD, tok, q);
    }
    if (!q->ok) {
      {p++; goto _out; }
    }
  }
	break;
	default:
	{{p = ((te))-1;}}
	break;
	}
	}
	break;
#line 494 "lexer.c"
		}
	}

_again:
	_acts = _query_actions + _query_to_state_actions[cs];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 ) {
		switch ( *_acts++ ) {
	case 0:
#line 1 "NONE"
	{ts = 0;}
	break;
#line 507 "lexer.c"
		}
	}

	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	if ( p == eof )
	{
	if ( _query_eof_trans[cs] > 0 ) {
		_trans = _query_eof_trans[cs] - 1;
		goto _eof_trans;
	}
	}

	_out: {}
	}

#line 184 "lexer.rl"
  

  if (q->ok) {
    RSQuery_Parse(pParser, 0, tok, q);
  }
  RSQuery_ParseFree(pParser, free);
  if (err) {
    *err = q->errorMsg;
  }

 
  return q->root;
}

